![GitHub Workflow Status (branch)](https://img.shields.io/github/workflow/status/Hannah-Sten/TeXiFy-IDEA/CI/master?style=flat-square)
[![Version](https://img.shields.io/jetbrains/plugin/v/9473-texify-idea.svg?style=flat-square)](https://plugins.jetbrains.com/plugin/9473-texify-idea)
[![View at JetBrains](https://img.shields.io/jetbrains/plugin/d/9473-texify-idea.svg?style=flat-square)](https://plugins.jetbrains.com/plugin/9473-texify-idea)
[![Join the chat at https://gitter.im/TeXiFy-IDEA/Lobby](https://img.shields.io/badge/gitter-join%20chat-green.svg?style=flat-square)](https://gitter.im/TeXiFy-IDEA)
[![Donate via PayPal](https://img.shields.io/badge/Donate!-PayPal-orange.png?style=flat-square)](https://www.paypal.me/HannahSchellekens)
[![codecov](https://img.shields.io/codecov/c/github/Hannah-Sten/TeXiFy-IDEA/master?style=flat-square)](https://codecov.io/gh/Hannah-Sten/TeXiFy-IDEA)

# TeXiFy-IDEA
LaTeX support for the IntelliJ Platform by [JetBrains](https://www.jetbrains.com/).

No idea where to start? Have a look at the [installation instructions](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Installation). Otherwise, take a look at the [tips](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Installation) instead, or browse through the documentation in the [Wiki](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features)

Create the most beautiful LaTeX documents with the user friendliness of the IntelliJ platform.
This plugin adds the tools to make creating LaTeX documents a breeze. We are currently doing our best to develop the plugin.

## Feedback and support
You can share new ideas/feature requests/bugs/calls for help in multiple ways:
1. Live chat via [gitter](https://gitter.im/TeXiFy-IDEA) (you can login with your GitHub account). Gitter also has a nice app, we use it to get notified of new activity.
2. [Issues](https://github.com/Hannah-Sten/TeXiFy-IDEA/issues). These may be bug reports, feature requests, user support, etc. Just generally anything you have a problem with/suggestion for. For general feedback we advise to use the gitter.

Please bear in mind that this is just a side project for us. It might take a while to fully process your feedback. We try our best :3

## Contributing
We would love it if you want to contribute to this project!
Please have a look at the [contributing guidelines](CONTRIBUTING.md) to get started.

## Features

* [Syntax highlighting](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Syntax-highlighting)
* [Autocompletion of labels, (custom defined) commands and environments](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Autocomplete)
* [Writer ergonomics - writing LaTeX made less cumbersome](https://www.jetbrains.com/idea/features/)
* [Compiler support for pdfLaTeX, LuaTeX, Latexmk, texliveonfly, XeLaTeX, bibtex, and biber](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Compilers)
* [Inspections. Intentions. And heaps more inspections](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features#inspections)
* [Full BibTeX support](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features#bibtex)
* [Formatter for LaTeX and BibTeX](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Code-formatting)
* [Structure view for LaTeX and BibTeX with filters](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Structure%20view)
* [Code folding for imports, sections, and environments](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Code-folding)
* [SumatraPDF (Windows)](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/SumatraPDF-support), [Evince (Linux)](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Evince-support), [Okular (Linux)](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Okular-support) and [Skim (MacOS)](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Skim-support) support with forward and backward search
* [Smart Quotes](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Smart-quotes)
* [Unicode math preview](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Preview#Unicode-math-preview)
* [Equation preview](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Preview#Equation-preview)
* [Gutter icons for quick compilation and file includes](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/File-inclusion-navigation)
* [Fancy icons that fit in with the IntelliJ style](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/UI#Icons)
* [Brace matching](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Brace-matching)
* [Word counting tool](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Menu-entries#Word-counting-tool)
* [File templates for .tex, .sty, .cls and .bib files](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Menu-entries#file-templates)
* [Automagically import packages of common commands](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Automatic-package-importing)
* [Go to declaration](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Go-to-declaration) and [find usages](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Find-usages) for labels, citations, and custom commands
* [Renaming of labels, citations, environments and files](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Refactoring)
* [Shortcuts for styling text](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features#menu-entries)
* [Line commenter](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Line-commenting)
* [Support for user-created document classes and packages](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/File-inclusion-navigation)

A more extensive (but not complete) list as well as documentation for these features can be found in the [Wiki](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features).
You can find IntelliJ documentation at https://www.jetbrains.com/idea/documentation/ and https://www.jetbrains.com/help/idea/.

## Installation instructions and getting started

See https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Installation for how to install everything you need to get up and running with TeXiFy-IDEA.

## Other helpful wiki links

* [Main documentation wiki page](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Features)
* [Troubleshooting issues with TeXiFy-IDEA](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Troubleshooting)
* [Installing alpha builds](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Alpha-builds) for the latest features.
* [Building the project from source](https://github.com/Hannah-Sten/TeXiFy-IDEA/wiki/Contributing-to-TeXiFy#building-from-source)

## Screenshots

![](https://plugins.jetbrains.com/files/9473/screenshot_19301.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19302.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19303.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19304.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19305.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19306.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19307.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19308.png)

![](https://plugins.jetbrains.com/files/9473/screenshot_19309.png)
